---
sidebar_position: 1
description: "推荐使用此方式进行一键安装。"
---

# 使用引擎扩展安装

---
## 前往 Cocos Store 下载

在 Cocos Store 搜索名为 **Cocos Service Pack** 的引擎扩展，或者 [点此跳转](pathname://TODO)。

这个扩展不是免费的，**但其唯一的作用就是帮助你管理服务包的版本（查看已安装版本、安装、卸载）。**

:::tip 常见问题

- **Service Pack 不是开源项目吗？？？**

    Service Pack 是完全开源的项目，这个引擎扩展只会为你提供自动化的安装方式，以后也只会有版本管理方面的功能。
    
    你可以选择 [手动安装](./installation-manual.md)，也只需要几步即可完成。

- **如何反馈有关这个扩展的问题或建议**

    若遇到与这个扩展相关的问题或者建议，不要在服务包的 Github 仓库反馈，请在扩展的 **商店评论区** 进行反馈。

    因为这个扩展的收益是个人的，所以也只由个人维护。

:::

---
## 一键安装

安装好扩展后，在 Cocos Creator 的菜单栏依次点击 **扩展 - 服务包管理**，会弹出服务包管理界面。

![plugin-ui](./assets/plugin-ui.png)

如果是支持的引擎版本，**安装服务包** 的按钮会亮起，点击之后等待安装完成，完成后重启编辑器即可。

:::note 扩展做了什么事

扩展帮您自动完成了手动安装时需要做的所有步骤，包括自定义引擎和放置 TypeScript 类型提示文件。

:::

预览项目并检查 Devtools Console 打印的是否为 `Cocos Creator SP v2.4.x`，是的话则已经成功安装。

![installedconsole](./assets/installed-console.png)

接下来推荐你从 [入门教程](../start-guide/start-guide-intro.mdx) 开始了解服务包为你的开发都带来了哪些新特性！

---
## 支持的引擎版本

服务包只会适配引擎的最新版本，如果需要在其它引擎版本上安装服务包，一般需要使用 Git Patch。

而这个扩展会额外适配其他引擎版本，让你可以在更多版本的引擎上一键安装。

**该扩展至少会维护两个 Cocos Creator 版本，分别是 v2.4.6 与最新版本。**

选择维护这两个版本是因为在 v2.4.7 这个版本出现了破坏性变更，也是官方开始暂停新特性开发只进行维护的版本。

也就是说：

- 项目使用 < v2.4.7 版本的引擎可以完全无痛升级至 v2.4.6。
- 项目使用 >= v2.4.7 版本的引擎可以完全无痛升级至最新版。
